#!/bin/bash

CMDNAME=`basename $0`

while getopts ab:g:m:j:h OPT
do
  case $OPT in
    "a" ) FLG_A="TRUE" ;;
    "b" ) FLG_B=${OPTARG} ;;
    "m" ) FLG_M=${OPTARG} ;;
    "j" ) FLG_J=${OPTARG} ;;
    "g" ) FLG_G=${OPTARG} ;;
      * ) echo "Usage: $CMDNAME [-a] [-b binpath] [-m 64] [-j n] [-g optimizeflag]" 1>&2
          exit 1 ;;
  esac
done

if [ "$FLG_M" = "64" ] ; then
    ARCH="ARCH=-m64";
else
    ARCH="ARCH=-m32";
fi

if [ "$FLG_B" = "" ] ; then
    BINPATH="";
else
    BINPATH="BINPATH=$FLG_B";
fi

if [ "$FLG_J" = "" ] ; then
    PARAMK=""
else
    PARAMK="-j$FLG_J"
fi

if [ "$FLG_G" = "" ] ; then
    MKOPT="OPT=-O2"
else
    MKOPT="OPT=\"$FLG_G\" STRIP="
fi

MAKEARGS="$BINPATH $ARCH $MKOPT $PARAMK"

if [ "$FLG_A" = "TRUE" ] ; then
    pushd win32 ; make clean ; /bin/bash -c "make $MAKEARGS" ; popd ;
fi
pushd win32frame ; make clean ; /bin/bash -c "make $MAKEARGS" ; popd ;
pushd util       ; make clean ; /bin/bash -c "make $MAKEARGS" ; popd ;
                   make clean ; /bin/bash -c "make $MAKEARGS"
